<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Tb;

/**
 * TbSearch represents the model behind the search form about `app\models\Tb`.
 */
class TbSearch extends Tb
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['tb_test_id', 'tb_test_q1', 'tb_test_q2', 'tb_test_q3', 'tb_test_q4', 'tb_test_q5', 'create_time', 'create_user', 'update_time', 'update_user'], 'integer'],
            [['tb_test_survey', 'tb_test_part_id', 'status','record_date'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Tb::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['record_date'=> SORT_DESC],
            ],
        ]);
        if(empty($params))
            $params = Yii::$app->request->post();
         $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'tb_test_id' => $this->tb_test_id,
            'tb_test_q1' => $this->tb_test_q1,
            'tb_test_q2' => $this->tb_test_q2,
            'tb_test_q3' => $this->tb_test_q3,
            'tb_test_q4' => $this->tb_test_q4,
            'tb_test_q5' => $this->tb_test_q5,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
        ]);

        $query->andFilterWhere(['like', 'tb_test_survey', $this->tb_test_survey])
            ->andFilterWhere(['like', 'tb_test_part_id', $this->tb_test_part_id])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
